# flake8: noqa
"""
Django settings for django_consensus project.

Generated by 'django-admin startproject' using Django 1.11.2.

For more information on this file, see
https://docs.djangoproject.com/en/1.11/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.11/ref/settings/
"""

import os
import ldap
from django_auth_ldap.config import LDAPSearch
from django_auth_ldap.config import GroupOfUniqueNamesType
# from django_auth_ldap.config import GroupOfNamesType

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.11/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'gwu*%m!*tv!#a(521e33^j2$g)eu$=c08exq6p*$&met!&23f5'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = [
    "127.0.0.1",
    "localhost",
]


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'jsoneditor',
    'sekizai',
    'social_django',
    'consensus_base',
    'sslserver'
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    # 'django.contrib.auth.middleware.RemoteUserMiddleware',
    'django_consensus.middleware.CustomHeaderMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'social_django.middleware.SocialAuthExceptionMiddleware',
]

ROOT_URLCONF = 'django_consensus.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': ["templates"],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
                'sekizai.context_processors.sekizai',
                'social_django.context_processors.backends',
                'social_django.context_processors.login_redirect',
                'consensus_base.context_processors.settings',
            ],
        },
    },
]

WSGI_APPLICATION = 'django_consensus.wsgi.application'


# Database
# https://docs.djangoproject.com/en/1.11/ref/settings/#databases
DATABASES = {
  'default': {
    'ENGINE': os.environ.get('DJANGO_DATABASE_ENGINE',
                           'django.db.backends.sqlite3'),
    'NAME': os.environ.get('DJANGO_DATABASE_NAME',
                           'consensus'),
    'USER': os.environ.get('DJANGO_DATABASE_USER',
                           ''),
    'PASSWORD': os.environ.get('DJANGO_DATABASE_PASSWORD',
                           ''),
    'HOST': '',
    'PORT': '',
  }
}


# Internationalization
# https://docs.djangoproject.com/en/1.11/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True


###############################################################################
# JSON Editor
###############################################################################
JSON_EDITOR_JS = '/static/jsoneditor-4.2.1/jsoneditor.min.js'
JSON_EDITOR_CSS = '/static/jsoneditor-4.2.1/jsoneditor.min.css'


###############################################################################
# Static content
###############################################################################
# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.11/howto/static-files/

MEDIA_URL = '/media/'
MEDIA_ROOT = os.path.join(BASE_DIR, "media/")
STATIC_URL = '/static/'
STATIC_ROOT = os.path.join(BASE_DIR, "static/")
STATICFILES_DIRS = [
# '/var/www/static/',
]


###############################################################################
# Logging
###############################################################################
LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'handlers': {
        'console': {
            'level': 'DEBUG',
            'class': 'logging.StreamHandler',
        },
    },
    'root': {
        'handlers': ['console'],
        'level': 'INFO',
    },
    'loggers': {}
}


###############################################################################
# AUTHENTICATION
###############################################################################
AUTHENTICATION_BACKENDS = (
    'django.contrib.auth.backends.RemoteUserBackend',
    'django_auth_ldap.backend.LDAPBackend',
    'django.contrib.auth.backends.ModelBackend',
)


###############################################################################
# AUTHENTICATION LDAP
###############################################################################

# Django LDAP doesn't check the issue. In other case, you need set the
# TLS_CACERT var ldap.conf file of your OS settings pointing to the actual
# certificate.
# AUTH_LDAP_GLOBAL_OPTIONS = {
#      ldap.OPT_X_TLS_REQUIRE_CERT: False,
#       ldap.OPT_REFERRALS: False,
# }


AUTH_LDAP_SERVER_URI = "ldap://localhost"

AUTH_LDAP_BIND_DN = ""
AUTH_LDAP_BIND_PASSWORD = ""
AUTH_LDAP_USER_SEARCH = LDAPSearch("ou=People,dc=company,dc=com",
                                   ldap.SCOPE_SUBTREE,
                                   "(uid=%(user)s)")
AUTH_LDAP_USERS_SEARCH = LDAPSearch("ou=People,dc=company,dc=com",
                                    ldap.SCOPE_SUBTREE,
                                    "(objectClass=inetOrgPerson)")
AUTH_LDAP_USERS_SEARCH_BLACKLIST = []
AUTH_LDAP_GROUP_SEARCH = LDAPSearch("ou=Groups,dc=company,dc=com",
                                    ldap.SCOPE_SUBTREE,
                                    "(objectClass=groupOfUniqueNames)")
AUTH_LDAP_GROUP_MEMBERS_SEARCH = LDAPSearch("ou=Group,dc=company,dc=com",
                                            ldap.SCOPE_SUBTREE,
                                            "(&(objectClass=groupOfUniqueNames)(cn=%(group)s))")
AUTH_LDAP_GROUP_SEARCH_WHITELIST = None  # Example: ['group1']

AUTH_LDAP_USER_ATTR_MAP = {
    "first_name": "givenName",
    "last_name": "sn",
    "email": "mail",
}


AUTH_LDAP_USER_FLAGS_BY_GROUP = {
    "is_active": "cn=staff,ou=Groups,dc=company,dc=com",
    "is_staff": "cn=staff,ou=Groups,dc=company,dc=com",
    "is_superuser": "cn=admins,ou=Groups,dc=company,dc=com"
}

# AUTH_LDAP_GROUP_TYPE = GroupOfNamesType()
AUTH_LDAP_GROUP_TYPE = GroupOfUniqueNamesType()
# https://pythonhosted.org/django-auth-ldap/_static/versions/1.0.19/index.html#django_auth_ldap.config.GroupOfUniqueNamesType

# AUTH_LDAP_REQUIRE_GROUP = "cn=enabled,ou=groups,dc=example,dc=com"
# AUTH_LDAP_DENY_GROUP = "cn=disabled,ou=groups,dc=example,dc=com"

# AUTH_LDAP_FIND_GROUP_PERMS = False
#
#   If True, LDAPBackend will furnish group permissions based on the LDAP groups
# the authenticated user belongs to. AUTH_LDAP_GROUP_SEARCH and
# AUTH_LDAP_GROUP_TYPE must also be set.
#
#     import django_auth_ldap.backend
#     b = django_auth_ldap.backend.LDAPBackend()
#     u = b.authenticate(username='user', password='password')
#     u.ldap_user.group_names
#     {'all', 'admin', 'staff'}
#
AUTH_LDAP_FIND_GROUP_PERMS = True
AUTH_LDAP_CACHE_GROUPS = True
AUTH_LDAP_GROUP_CACHE_TIMEOUT = 60



AUTH_LDAP_CONNECTION_OPTIONS = {
    ldap.OPT_REFERRALS: 0
}

LOGGING['loggers']['django_auth_ldap'] = {
    'handlers': ['console'],
    'level': 'DEBUG',
}

###############################################################################
# Django Login
###############################################################################

## LOGIN_URL = 'two_factor:login'
## LOGIN_REDIRECT_URL = 'two_factor:profile'


###############################################################################
# consensus settings
###############################################################################
CONSENSUS_INTERNAL_AUTH = False
CONSENSUS_USE_LDAP = False
CONSENSUS_LOGO_URL = None
CONSENSUS_SUPPORT_URL = "https://riot.igalia.com/#/room/#igalia-support"
CONSENSUS_PROFILE_URL = "https://sso.igalia.com/account/two_factor/"
CONSENSUS_SUPPORT_URL = "https://riot.igalia.com/#/room/#igalia-support:igalia.com"
CONSENSUS_LOGOUT_URL = "https://sso.igalia.com/logout/"
CONSENSUS_REMOTE_USER_HEADER = "HTTP_OIDC_CLAIM_SUB"
CONSENSUS_POLL_QUESTION_TYPE_DEFAULT = "consensus_poll_question_type_vote"
CONSENSUS_POLL_QUESTION_TYPE_CHOICES = [
    ("consensus_poll_question_type_vote", "Vote"),
    ("consensus_poll_question_type_weights", "Weights"),
    ("consensus_poll_question_type_feedback", "Feedback"),
]
CONSENSUS_POLLS_PAGINATOR_ITEMS = 25
LOGGING['loggers']['consensus_base'] = {
    'handlers': ['console'],
    'level': 'DEBUG',
}

CONSENSUS_MAIL_SENDER = "consensus-no-reply@igalia.com"
CONSENSUS_MAIL_POLL_URL_PATTERN = "https://consensus.igalia.com/poll/%s"

EMAIL_HOST="127.0.0.1"
EMAIL_PORT=25

# CELERY STUFF
CELERY_BROKER_URL='redis://127.0.0.1:6379/0'
CELERY_RESULT_BACKEND = 'redis://localhost:6379'
CELERY_ACCEPT_CONTENT = ['application/json']
CELERY_TASK_SERIALIZER = 'json'
CELERY_RESULT_SERIALIZER = 'json'
CELERY_TIMEZONE = 'UTC'

###############################################################################
# Local settings
###############################################################################
try:
    from django_consensus.local_settings import *
except ImportError:
    pass
